* DETAB$
*
* pjwitte 2o22+
* All code is my own work except as and where stated
*
* V0.05, pjw, 2022 Apr 27, no dependencies, rewrite
*
* Compatible with QDOS, Minerva and SMSQ/E
*


        section code

        xdef DETAB

        include dev8_keys_sbasic
        include dev8_keys_qlv
        include dev8_keys_k
        include dev8_keys_err


*
DETAB
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* S*BASIC Function to remove leading tabs and spaces from string
*
* text$ = DETAB$(string$)
*

        move.w sb.gtstr,a2
        jsr (a2)
        bne.s exit

        subq.w #1,d3            one par only
        bne.s err_bp

        move.w (a6,a1.l),d0
        beq.s return

        move.l d0,d1            d1.l = original len
        addq.l #1,a1            skip len (partially)
        bra.s lend

loop
        move.b (a6,a1.l),d2
        cmpi.b #k.space,d2
        beq.s lend

        cmpi.b #k.tab,d2
        bne.s exloop

lend
        addq.l #1,a1            next char
        dbra d0,loop

        moveq #0,d2             len must be null so return null string
        bra.s setl

err_bp
        moveq #err.ipar,d0
exit
        rts

exloop
        moveq #1,d2
        add.w d0,d2             d2.w = new len

        btst #0,d2              is new len odd?
        beq.s nle                no, new length even

        btst #0,d1               yes, was old len odd?
        bne.s setl                yes, set length and return

        movea.l a1,a2             no, old length even, so shift string left
        subq.l #1,a1
ssl
        move.b (a6,a2.l),-1(a6,a2.l)
        addq.l #1,a2
        dbra d0,ssl
        bra.s setl

nle
        btst #0,d1              new len even. Was old len odd?
        beq.s setl               no, set length and return

        lea.l (a1,d2.w),a2      a2 -> end string
        addq.l #1,a1
        addq.l #1,d1            !

ssr
        move.b -1(a6,a2.l),(a6,a2.l)    shift string right
        subq.l #1,a2
        dbra d0,ssr

setl
        move.w d2,-2(a6,a1.l)   set length
        sub.l d2,d1             delta
        bclr #0,d1
        add.l d1,sb_arthp(a6)   update stack pointer

return
        moveq #ar.strng,d4      return string
        moveq #0,d0
        rts

*
        end
